/*
EEPROM Api Header File By NeO_2kX
*/

.equ Patch_Start					0x007015EC

@EEPROM
.equ hfd2_30ReadBlockNameInRamImage	0x00006420
.equ hfd2_31SaveBlockNameInRamImage	0x00006484

@MEM
.equ memmove						0x003E1444
.equ memset							0x003E13E0
.equ MemMgr_Allocate				0x00395FEA
.equ MemMgr_Deallocate				0x003960B2

@T9Res
.equ T9Res_ReadUdbData				0x002388C4
.equ T9Res_WriteUdbData				0x002389B8

@FFS
.equ ffsOpenDir						0x002C1298			@
.equ ffsReadDir						0x002C1370			 @ Dir
.equ ffsCloseDir					0x002C14A4			 @ Func
.equ ffsGetNumOfFiles 				0x002C3604			@
.equ ffsGetFileSize					0x002C1044

.equ ffsOpenFile					0x002C0374	; (int* handle, char* filename, mode):(int)
.equ ffsReadFile					0x002C0684	; (int handle, void* buf, bytestoread, bytesread*):(int)
.equ ffsCloseFile					0x002C060C	; (int handle)
.equ ffsCreateFile					0x002C0418	; (int* handle, char* filename, mode(8)):(int)
.equ ffsWriteFile					0x002C0820
.equ ffsSeekFile                	0x002C3498

@Macro
.macro ExternalFunc name adress
.align 2
\name:
PUSH 	{R0, R1}
	LDR 	R0, _\name
	STR 	R0 ,[SP, #4]
POP 	{R0, PC}
_\name: .word \adress+1
.endm
