/*
Keypad Backlight Header By NeO_2kX
*/

@Main
.equ KeyPad_Start					0x003FC542

@Stdlib
.equ atoi							0x000B69D8 @(const char *str):(int str)

@Edit
.equ lk3_0InitEditBuffer			0x00099B34 @(void)
.equ lk3_2WriteEditBuffer			0x00099C58 @(*chr str)
.equ lk3_1SetEditBufferPosition		0x00099BE6 @(int pos)
.equ lk3_3ReadEditBuffer			0x00099CB8 @(void):(*str)

@EEPROM Api
.equ Read_EEPROM					0x00701604
.equ Write_EEPROM					0x00701638

@Time
.equ RtcGetTime						0x000B68F0	@(char* buf):{sec,min,hour, 0,0}
.equ lk_GetTimeString				0x000B703A	@(To, From, 0, 0)
.equ lk_ChangeTimeFormat			0x000B6FD0

@Debug
.equ ShowRegs 						0x003F904C	@(void)

@MCC
.equ mcc_set_backlight 				0x007EDA88
.equ mcc_set_exit					0x007EBDA8
.equ mcc_set_end					0x007EBDF8
.equ mcc_set_backlight_15sec 		0x007EDB28
.equ mcc_set_backlight_30sec		0x007EDB78
.equ mcc_set_backlight_1min			0x007EDBC8
.equ mcc_set_backlight_3min			0x007EDC18
.equ mcc_set_backlight_10min		0x007EDC68

@Mem
.equ memset							0x003E13E0	@(void *dest, int c, size_t count):(value of dest) 
.equ memmove						0x003E1444	@(void *dest, const void *src, size_t count):(void *dest)
.equ MemMgr_Allocate				0x00395FEA
.equ MemMgr_Deallocate				0x003960B2
.equ RtkGetMemory					0x002C9760
.equ RtkReleaseMemory				0x002C9768
.equ memcmp							0x003E214C	@(const void *buf1, const void *buf2, size_t count):(result)
.equ __16_memcpy					0x003E1578

@List
.equ CreateList						0x000B2142
.equ AddList						0x000B2190
.equ SetCurList						0x000B677C

@String
.equ GetString						0x000A9564
.equ _sprintf						0x003E1710
.equ strcmp 						0x003E1690	@(const char *string1, const char *string2):(result)
.equ strchr							0x003E228C	@(const char *str, int c):(pointer)
.equ lk_get_text					0x002BE700	
.equ strcat							0x003E2188	@(char *strDestination, const char *strSource):(char *strDestination)
.equ strlen							0x003E1758	@(const char *str):(num_of_char)
.equ strcpy							0x003E1618	@(char *strDestination, char *strSource):(*strDestination)

@SK
.equ lk_get_sofk					0x002BE774
.equ Reg_Draw_Softkey				0x000A99F6

@Other
.equ exit_hen7_80SwitchOnMainlight 	0x00128A4C
.equ Reg_Draw_Title					0x000B1A18 	@{Title_Str_Adress, ?(0), ?(0)}

@Var
.equ DspList 						0x01656E68	@List struct
.equ TimeBuf						0x017A3284	@Time buffer
.equ Org_SysTime					0x017A2014
.equ TimeFormat						0x017A2BDC	@0 - 24, 1 - 12
.equ AMPM							0x017A3464	@0 - AM, 1 - PM

@FFS
.equ ffsOpenDir						0x002C1298			@
.equ ffsReadDir						0x002C1370			 @ Dir
.equ ffsCloseDir					0x002C14A4			 @ Func
.equ ffsGetNumOfFiles 				0x002C3604			@
.equ ffsGetFileSize					0x002C1044
.equ ffsOpenFile					0x002C0374	; (int* handle, char* filename, mode):(int)
.equ ffsReadFile					0x002C0684	; (int handle, void* buf, bytestoread, bytesread*):(int)
.equ ffsCloseFile					0x002C060C	; (int handle)
.equ ffsCreateFile					0x002C0418	; (int* handle, char* filename, mode(8)):(int)
.equ ffsWriteFile					0x002C0820
.equ ffsSeekFile                	0x002C3498

@EEPROM
.equ hfd2_30ReadBlockNameInRamImage	0x00006420
.equ hfd2_31SaveBlockNameInRamImage	0x00006484
