;--------------------------------------------------
;|PatchName -         |
;|Group     -                            |
;|Version   - 1                                 |
;|Phone     - SAMSUNG SGH-D600E                    |
;|Firmware  - D600EXEFA1                           |
;|Author    - Freeman                             |
;|Coded     - Freeman & [AlaSToR]                 |
;|Begin     - 04.01.2009 (v.1)                    |
;|Begin     - 05.01.2009 (v.2)                    |
;|Place     - SnoWTowN at HomE   =(A)=            |
;|HelloTo:  - mdemonv,vvyura,Freeman,micha,Sylar, |
;|RDG,Pako777,Kir232006,CNFP,tema172,bugimen,Mako,|
;|KR-Electronics,SergeiBog,-=AsteriX=-,leo17582,  |
;|s_a_m87,Longhair,Shagrath,igo,Artyomcool,Javer, |
;|Dimanchik,NeO_2kX,dymastyj,StepanV,Slyder,, |
;|Kapibara,VlasTV,das,AlexeyK,yuretasdert,,  |
;|Buzzzzer,BaHbok,˨,S04HbIY,sergmarin,Igorechin.|
;=================================================|
;    CODED FOR SAMSUNG SGH-D900 Mobile Phone      |
;=================================================|

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                      ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.equ gv_Call_Log_Menu_Index             0x1833BC36;;	;D600E
.equ 	lk_AddMenu                		0x111F6A0C
.equ	gs_DspMenu 			0x1837BE74
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;; < > ;;;;;;;;;;;;;;;;;;;;;
.start 0x10D78FA4 ;dir3_7GetCallLogData (7C05 2C)	;D600E
	ldr  r0,=AllCallLogs_PopupNumber+1
	bx   r0
.data

.start 0x100D6D78 ;dir3_5MakeMenuComponents		;D600E
	ldr  r1,=MakeMenuComponents_PopupNumber+1
	bx   r1
.data

.start 0x115BEF24 ;dir3_6MakeMenuComponents_Last	;D600E
	ldr  r1,=MakeMenuComponents_LastPopupNumber+1
	bx   r1
.data

;;;;;;;;;;;;;;;;;; </ > ;;;;;;;;;;;;;;;;;;;;

.start 0x10BFA1EF
;;;;;;;;;;;;;;;;;;;;;;; THUMB ;;;;;;;;;;;;;;;;;;;;;;;;;;
AllCallLogs_PopupNumber:
	ldrb r0,[r2,0xB]
	
	cmp  r0,0
	beq  AllCallLogs_DrawOnlyNumber
	
	cmp  r0,0xFF
	bne  AllCallLogs_DrawContactNameWithHisNumber

AllCallLogs_DrawOnlyNumber:
	str  r1,[r4,4]
		
	b    AllCallLogs_CountNumCalls
;;;;;;;;;;;;;;	
AllCallLogs_DrawContactNameWithHisNumber:
	add  r1,0x2B
	STR 	R1, [R4, #0x4]
	str  r1,[r4,0x28]

AllCallLogs_CountNumCalls:
	ldr  r0,=0x10D78FB4+1		;D600E
	bx   r0
.data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MakeMenuComponents_PopupNumber:
	ldr  r1,=gv_Call_Log_Menu_Index		;D600E
	cmp  r0,0
	ldrb r1,[r1]
	beq  MakeMenuComponents_DrawOnlyNumber
	
	cmp  r0,0xFF
	bne  MakeMenuComponents_DrawContactNameWithNumber
	
MakeMenuComponents_DrawOnlyNumber:
	ldr  r0,=0x100D6D84+1		;D600E
	bx   r0
;;;;;;;;;;;;;;
MakeMenuComponents_DrawContactNameWithNumber:
	mov  r7,r3
	mov  r2,0
	str  r2,[sp]
	mov  r2,0x18 ;1C
	mov  r3,r5
	ldr  r1,=gv_Call_Log_Menu_Index
	ldrb r1,[r1]
	ldr  r0,=gs_DspMenu
	bl   lk_AddMenu

	mov  r2,0
	str  r2,[sp]
	mov  r2,0x1E ;22
	mov  r3,r7
	ldr  r7,=gs_DspMenu
	ldr  r1,=gv_Call_Log_Menu_Index
	ldrb r1,[r1]
	mov  r0,r7
	bl   lk_AddMenu
	
	ldr  r0,=0x100D6DA0+1		;D600E
	bx   r0
.data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MakeMenuComponents_LastPopupNumber:
	ldr  r1,=gv_Call_Log_Menu_Index
	cmp  r0,0
	ldrb r1,[r1]
	beq  MakeMenuComponents_LastDrawOnlyNumber
	
	cmp  r0,0xFF
	bne  MakeMenuComponents_LastDrawContactNameWithNumber
	
MakeMenuComponents_LastDrawOnlyNumber:
	ldr  r0,=0x115BEF30+1		;D600E
	bx   r0
;;;;;;;;;;;;;;
MakeMenuComponents_LastDrawContactNameWithNumber:
	mov  r7,r3
	mov  r2,0
	str  r2,[sp]
	mov  r2,0x18 ;1C
	mov  r3,r5
	ldr  r1,=gv_Call_Log_Menu_Index
	ldrb r1,[r1]
	ldr  r0,=gs_DspMenu
	bl   lk_AddMenu

	mov  r2,0
	str  r2,[sp]
	mov  r2,0x1E ;22
	mov  r3,r7
	ldr  r7,=gs_DspMenu
	ldr  r1,=gv_Call_Log_Menu_Index
	ldrb r1,[r1]
	mov  r0,r7
	bl   lk_AddMenu
	
	ldr  r0,=0x115BEF4C+1		;D600E
	bx   r0
.data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;